/*
** wiregl_bbox.h
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#ifndef WIREGLGLBBOX_H
#define WIREGLGLBBOX_H

#include "wiregl/glcontext/glbase.h"
#include "wiregl/include/wireGL.h"

#ifdef __cplusplus
extern "C" {
#endif

extern GLvectorf bounds_min;
extern GLvectorf bounds_max;
extern GLint vertex_count;
extern GLint vertex_max;

extern GLapi vertexBBapi[];
extern GLapi vertexCapi[];

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB2d )( GLdouble x, GLdouble y );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB2dv )( const GLdouble *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB2f )( GLfloat x, GLfloat y );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB2fv )( const GLfloat *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB2i )( GLint x, GLint y );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB2iv )( const GLint *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB2s )( GLshort x, GLshort y );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB2sv )( const GLshort *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB3d )( GLdouble x, GLdouble y, GLdouble z );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB3dv )( const GLdouble *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB3f )( GLfloat x, GLfloat y, GLfloat z );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB3fv )( const GLfloat *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB3i )( GLint x, GLint y, GLint z );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB3iv )( const GLint *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB3s )( GLshort x, GLshort y, GLshort z );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB3sv )( const GLshort *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB4d )( GLdouble x, GLdouble y, GLdouble z, GLdouble w );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB4dv )( const GLdouble *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB4f )( GLfloat x, GLfloat y, GLfloat z, GLfloat w );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB4fv )( const GLfloat *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB4i )( GLint x, GLint y, GLint z, GLint w );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB4iv )( const GLint *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB4s )( GLshort x, GLshort y, GLshort z, GLshort w );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexBB4sv )( const GLshort *v );

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC2d )( GLdouble x, GLdouble y );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC2dv )( const GLdouble *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC2f )( GLfloat x, GLfloat y );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC2fv )( const GLfloat *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC2i )( GLint x, GLint y );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC2iv )( const GLint *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC2s )( GLshort x, GLshort y );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC2sv )( const GLshort *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC3d )( GLdouble x, GLdouble y, GLdouble z );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC3dv )( const GLdouble *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC3f )( GLfloat x, GLfloat y, GLfloat z );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC3fv )( const GLfloat *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC3i )( GLint x, GLint y, GLint z );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC3iv )( const GLint *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC3s )( GLshort x, GLshort y, GLshort z );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC3sv )( const GLshort *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC4d )( GLdouble x, GLdouble y, GLdouble z, GLdouble w );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC4dv )( const GLdouble *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC4f )( GLfloat x, GLfloat y, GLfloat z, GLfloat w );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC4fv )( const GLfloat *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC4i )( GLint x, GLint y, GLint z, GLint w );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC4iv )( const GLint *v );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC4s )( GLshort x, GLshort y, GLshort z, GLshort w );
void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( VertexC4sv )( const GLshort *v );

#ifdef __cplusplus
}
#endif

#endif /* WIREGLGL_H */

