/*
** misc_vectors.c
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#include "wiregl/include/wireGL.h"
#include "wiregl/include/wiregl_protocol.h"

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( EdgeFlagv  )( const GLboolean *e )
{
	WIREGL_PACK_FUNCTION( EdgeFlag  )( *e );
}

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( Indexdv  )( const GLdouble *c )
{
	WIREGL_PACK_FUNCTION( Indexd  )( *c );
}

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( Indexfv  )( const GLfloat *c )
{
	WIREGL_PACK_FUNCTION( Indexf  )( *c );
}

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( Indexiv  )( const GLint *c )
{
	WIREGL_PACK_FUNCTION( Indexi  )( *c );
}

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( Indexsv  )( const GLshort *c )
{
	WIREGL_PACK_FUNCTION( Indexs  )( *c );
}

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( Indexubv  )( const GLubyte *c )
{
	WIREGL_PACK_FUNCTION( Indexub  )( *c );
}

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( Rectdv  )( const GLdouble *v1, const GLdouble *v2 )
{
	WIREGL_PACK_FUNCTION( Rectd  )( v1[0], v1[1], v2[0], v2[1] );
}

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( Rectfv  )( const GLfloat *v1, const GLfloat *v2 )
{
	WIREGL_PACK_FUNCTION( Rectf  )( v1[0], v1[1], v2[0], v2[1] );
}

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( Rectiv  )( const GLint *v1, const GLint *v2 )
{
	WIREGL_PACK_FUNCTION( Recti  )( v1[0], v1[1], v2[0], v2[1] );
}

void OPENGL_APIENTRY WIREGL_PACK_FUNCTION( Rectsv  )( const GLshort *v1, const GLshort *v2 )
{
	WIREGL_PACK_FUNCTION( Rects  )( v1[0], v1[1], v2[0], v2[1] );
}


