/*
** packer_internals.c
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#ifndef WIREGL_PACKER_INTERNALS_H
#define WIREGL_PACKER_INTERNALS_H

#include "wiregl/include/wireGL.h"
#include "wiregl/glcontext/glcontext.h"

GLint __gl_ComputePixelPointer2D( GLint width,
		GLcontext *ctx, GLenum format, GLenum type, GLint *rowSize );

GLint __gl_PixelSizeInBytes( GLenum format, GLenum type );

GLint __gl_TypeSize( GLenum type );
void __Snarf2DPixelData( char *dest_ptr, GLsizei width, GLsizei height, 
		GLenum format, GLenum type, const GLvoid *pixels );

#endif /* WIREGL_PACKER_INTERNALS_H */

