/*
** drawpixels.c
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#ifdef WINDOWS
#include <windows.h>
#endif
#include <GL/gl.h>

#include "wiregl/include/wireGL.h"
#include "wiregl/include/wiregl_protocol.h"
#include "wiregl/include/wiregl_pipe.h"
#include "wiregl/include/wiregl_util.h"

void __decodeDrawPixels( void  )
{
	glPixelStorei( GL_UNPACK_ROW_LENGTH, 0 );
	glPixelStorei( GL_UNPACK_SKIP_PIXELS, 0 );
	glPixelStorei( GL_UNPACK_SKIP_ROWS, 0 );
	glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );
	
	glDrawPixels(
		READ_DATA( sizeof( int ) + 0, GLsizei ),	/* width */
		READ_DATA( sizeof( int ) + 4, GLsizei ),	/* height */
		READ_DATA( sizeof( int ) + 8, GLenum ),	/* format */
		READ_DATA( sizeof( int ) + 12, GLenum ),	/* type */
		DATA_POINTER( sizeof( int ) + 16, GLvoid ) /* pixels */
		 );
	INCR_VAR_PTR();
}

void __decodeBitmap( void  )
{	
  unsigned int packetlen = READ_DATA(0, int);
	GLubyte *p = (GLubyte *) 0;
	if (packetlen > 7*sizeof(int))
		p = DATA_POINTER ( sizeof (int) + 24, GLubyte);

	glPixelStorei( GL_UNPACK_ROW_LENGTH, 0 );
	glPixelStorei( GL_UNPACK_SKIP_PIXELS, 0 );
	glPixelStorei( GL_UNPACK_SKIP_ROWS, 0 );
	glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );
	glBitmap( 
			READ_DATA( sizeof( int ) + 0, GLsizei ), /* width */
			READ_DATA( sizeof( int ) + 4, GLsizei ), /* height */
			READ_DATA( sizeof( int ) + 8, GLfloat ), /* xorig */
			READ_DATA( sizeof( int ) + 12, GLfloat ), /* yorig */
			READ_DATA( sizeof( int ) + 16, GLfloat ), /* xmove */
			READ_DATA( sizeof( int ) + 20, GLfloat ), /* ymove */
			p  /* bitmap */
			);
	INCR_VAR_PTR();
}
