/*
** lights.c
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#ifdef WINDOWS
#include <windows.h>
#endif
#include <GL/gl.h>

#include "wiregl/include/wireGL.h"
#include "wiregl/include/wiregl_protocol.h"
#include "wiregl/include/wiregl_pipe.h"
#include "wiregl/include/wiregl_util.h"

void __decodeLightfv( void  )
{
	glLightfv(
		READ_DATA( sizeof( int ) + 0, GLenum ),	/* light */
		READ_DATA( sizeof( int ) + 4, GLenum ),	/* value */
		DATA_POINTER( sizeof( int ) + 8, GLfloat )	/* params */
		 );
	INCR_VAR_PTR();
}

void __decodeLightiv( void  )
{
	glLightiv(
		READ_DATA( sizeof( int ) + 0, GLenum ),	/* light */
		READ_DATA( sizeof( int ) + 4, GLenum ),	/* value */
		DATA_POINTER( sizeof( int ) + 8, GLint )	/* params */
		 );
	INCR_VAR_PTR();
}

void __decodeLightModelfv( void  )
{
	glLightModelfv( 
			READ_DATA( sizeof( int ) + 0, GLenum ), /* pname */
			DATA_POINTER( sizeof( int ) + 4, GLfloat ) /* params */
			);
	INCR_VAR_PTR();
}

void __decodeLightModeliv( void  )
{
	glLightModeliv( 
			READ_DATA( sizeof( int ) + 0, GLenum ), /* pname */
			DATA_POINTER( sizeof( int ) + 4, GLint ) /* params */
			);
	INCR_VAR_PTR();
}
