/*
** map.c
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#ifdef WINDOWS
#include <windows.h>
#endif
#include <GL/gl.h>

#include "wiregl/include/wireGL.h"
#include "wiregl/include/wiregl_protocol.h"
#include "wiregl/include/wiregl_pipe.h"
#include "wiregl/include/wiregl_util.h"

#include <stdio.h>

void __decodeMap2d( void  )
{
	glMap2d(
		READ_DATA( sizeof( int ) + 0, GLenum ),	/* target */
		READ_DATA( sizeof( int ) + 4, GLdouble ),	/* u1 */
		READ_DATA( sizeof( int ) + 12, GLdouble ),	/* u2 */
		READ_DATA( sizeof( int ) + 20, GLint ),	/* ustride */
		READ_DATA( sizeof( int ) + 24, GLint ),	/* uorder */
		READ_DATA( sizeof( int ) + 28, GLdouble ),	/* v1 */
		READ_DATA( sizeof( int ) + 36, GLdouble ),	/* v2 */
		READ_DATA( sizeof( int ) + 44, GLint ),	/* vstride */
		READ_DATA( sizeof( int ) + 48, GLint ),	/* vorder */
		DATA_POINTER( sizeof( int ) + 52, GLdouble ) /* points */
			 );
	INCR_VAR_PTR();
}

void __decodeMap2f( void  )
{
	glMap2f(
		READ_DATA( sizeof( int ) + 0, GLenum ),	/* target */
		READ_DATA( sizeof( int ) + 4, GLfloat ),	/* u1 */
		READ_DATA( sizeof( int ) + 8, GLfloat ),	/* u2 */
		READ_DATA( sizeof( int ) + 12, GLint ),	/* ustride */
		READ_DATA( sizeof( int ) + 16, GLint ),	/* uorder */
		READ_DATA( sizeof( int ) + 20, GLfloat ),	/* v1 */
		READ_DATA( sizeof( int ) + 24, GLfloat ),	/* v2 */
		READ_DATA( sizeof( int ) + 28, GLint ),	/* vstride */
		READ_DATA( sizeof( int ) + 32, GLint ),	/* vorder */
		DATA_POINTER( sizeof( int ) + 36 , GLfloat ) /* points */
			 );
	INCR_VAR_PTR();
}

void __decodeMap1d( void  )
{
	glMap1d(
		READ_DATA( sizeof( int ) + 0, GLenum ),	/* target */
		READ_DATA( sizeof( int ) + 4, GLdouble ),	/* u1 */
		READ_DATA( sizeof( int ) + 12, GLdouble ),	/* u2 */
		READ_DATA( sizeof( int ) + 20, GLint ),	/* stride */
		READ_DATA( sizeof( int ) + 24, GLint ),	/* order */
		DATA_POINTER( sizeof( int ) + 28, GLdouble ) /* points */
			 );
	INCR_VAR_PTR();
}

void __decodeMap1f( void  )
{
	glMap1f(
		READ_DATA( sizeof( int ) + 0, GLenum ),	/* target */
		READ_DATA( sizeof( int ) + 4, GLfloat ),	/* u1 */
		READ_DATA( sizeof( int ) + 8, GLfloat ),	/* u2 */
		READ_DATA( sizeof( int ) + 12, GLint ),	/* stride */
		READ_DATA( sizeof( int ) + 16, GLint ),	/* order */
		DATA_POINTER( sizeof( int ) + 20, GLfloat ) /* points */
			 );
	INCR_VAR_PTR();
}
