/*
** misc.c
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#include "wiregl/include/wireGL.h"
#include "wiregl/include/wiregl_protocol.h"
#include "wiregl/include/wiregl_pipe.h"
#include "wiregl/include/wiregl_util.h"

void __decodeGMDeath( void  )
{
	fprintf( stderr, "Looks like the GM client died..." );
	exit(0);
}

void __decodeEnable( void )
{
	GLenum cap = READ_DATA( 0, GLenum );
	__gltrack_Enable( cap  );
	INCR_DATA_PTR( 4 );
}

void __decodeBlendFunc( void )
{
	GLenum sfactor = READ_DATA( 0, GLenum );
	GLenum dfactor = READ_DATA( 4, GLenum );
	__gltrack_BlendFunc( sfactor, dfactor  );
	INCR_DATA_PTR( 8 );
}