/*
** mem.c
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#include "__utilsource.h"

#include "wiregl/include/wiregl_util.h"
#include <stdlib.h>

UTIL_DECL void *wireGLAlloc( unsigned int bytes )
{
 if (bytes > WIREGL_MAX_PACKET_SIZE)
	wireGLSimpleError( "%d bytes is too much.", bytes );

	void *ret = malloc( bytes );
	if (!ret)
		wireGLError( "Couldn't allocate %d bytes!", bytes );
	return ret;
}

UTIL_DECL void wireGLFree( void *ptr )
{
	if (!ptr)
		return;
	free(ptr);
}
