/*
** url.c
** http://graphics.stanford.edu/software/wiregl
**
** Copyright  2000 The Board of Trustees of The Leland Stanford Junior
** University. All rights reserved.
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or modify
** this software, provided that the above copyright notice and this
** permission notice appear in all copies of this software.  No part of
** this software or any derivatives thereof may be used in graphics systems
** for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind, 
** express, implied or otherwise, including without limitation, any warranty 
** of merchantability or fitness for a particular purpose.
**
*/

#include "__utilsource.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "wiregl/include/wiregl_util.h"

static void useful_strncpy( char *dst, char *src, int len )
{
	strncpy( dst, src, len );
	dst[len] = '\0';
}

UTIL_DECL int wireGLParseURL( char *url, char *protocol, char *hostname, int *port, int default_port )
{
	char *temp = strchr( url, ':' );
	char *temp2, *temp3;
	if (!temp)
		return 0;
	useful_strncpy( protocol, url, temp-url );
	temp += strlen( "://" );
	temp2 = strchr( temp, '/' );
	if (!temp2)
	{
		temp2 = temp + strlen( temp );
	}
	temp3 = strchr( temp, ':' );
	if (!temp3 || temp3 > temp2)
	{
		*port = default_port;
		useful_strncpy( hostname, temp, temp2-temp );
	}
	else
	{
		sscanf( temp3+1, "%d", port );
		useful_strncpy( hostname, temp, temp3-temp );
	}
	return 1;
}
